<?            
//    

   require_once("t_sql.php");


class T_MODER extends T_SQL {
   var $time; // 
   var $answers; //   
   var $id; //id 
   var $title1; // 
   var $message_text1; // 
   var $user_name; // 
   var $user_id; //id 
   var $password; // 
   var $errors; //,  \n
   var $user_answers; //  
   var $last_answer_un; //    -   
   var $email; //  
   var $last_answer_time; //   
   var $registration_time; //  
   var $moderated_topic; //  
   var $moderated_message; //  
   var $changed_message; //  


///////////////////////////////////////////////////////////////////////
// 
function T_MODER(){
   parent::T_SQL("FORUM");
}


///////////////////////////////////////////////////////////////////////
function get_title(){
  return htmlspecialchars(trim($this->title1));

}


///////////////////////////////////////////////////////////////////////
function get_message_text(){
  return nl2br(htmlspecialchars(trim($this->message_text1)));

}








///////////////////////////////////////////////////////////////////////
function log_history($topic_id, $message_id, $event, $user_id, $user_name, $message_text){
   parent::prepare("INSERT INTO `history` (`topic_id`, `message_id`, `event` , `user_name`, `user_id`, `updated_unixtime`, `message_text`)  VALUES (?, ?, ?, ?, ?, ?, ?)");
   parent::bind($topic_id);
   parent::bind($message_id);
   parent::bind($event);
   parent::bind($user_name);
   parent::bind($user_id);
   parent::bind(time());
   parent::bind($message_text);
   $s=parent::getsql();
   parent::query($s);
}


///////////////////////////////////////////////////////////////////////
// -1 ( ),    ,
//0 -   ,   
//1 -   
function IsModerator($user_name, $password){
   parent::prepare("SELECT `id`, `moderator`, `user_name`, `password` FROM `users` WHERE `user_name`=? ");
   parent::bind(trim($user_name));
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $moderator1=parent::field("moderator");
     $password1=trim(parent::field("password"));
     $user_id=parent::field("id");
   }else{
     $this->errors="     : ".$user_name;
     return -1;
   }

   if($password1!==md5(trim($password))){
     $this->errors="   : ".$user_name;
     return -1;
   }
  if($moderator1==1){
     return 1;
  }else{
     return 0;
  }
}





///////////////////////////////////////////////////////////////////////
// 
function DeleteTopic($topic_id, $user_name, $password){
//,    
   parent::prepare("SELECT `id`, `moderated`, `answers` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $moderated=parent::field("moderated");
     $answers=parent::field("answers");
   }else{
     throw new Exception("   ID=".$topic_id);
   }


   if($moderated==="D"){
     $this->errors="     ID=".$topic_id;
     return FALSE;
   }

//  
   parent::prepare("SELECT `id`, `topic_id`, `user_name` FROM `messages` WHERE `topic_id`=? AND `id`=0");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
   }else{
     throw new Exception("     ID=".$topic_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   parent::begin_transaction(); // 

   if($moderator1!=1){
     if(trim($user_name1)===trim($user_name)){
       if($answers!=0){
          parent::rollback_transaction();
          $this->errors="    ,      .";
          return FALSE;
       }
     }else{
          parent::rollback_transaction();
          $this->errors="       .";
          return FALSE;
     }
   }

   //   
   parent::prepare("UPDATE `topics` SET `moderated`=?, `search_dumped`=0 WHERE `id`=?");
   parent::bind("D");
   parent::bind($topic_id);
   
   $s=parent::getsql();
   parent::query($s);

   //    
   $this->log_history($topic_id, 0, "D", $this->user_id, $user_name, "  id=".$topic_id);

   parent::commit_transaction(); // 

   return TRUE;

}




///////////////////////////////////////////////////////////////////////
// 
function DrawnTopic($topic_id, $user_name, $password){
//,    
   parent::prepare("SELECT `id`, `moderated`, `answers` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);



   if(parent::fetch()){
     $moderated=parent::field("moderated");
     $answers=parent::field("answers");
   }else{
     throw new Exception("   ID=".$topic_id);
   }


   if($moderated==="V"){
     $this->errors="     ID=".$topic_id;
     return FALSE;
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
          $this->errors="    .";
          return FALSE;
   }

   parent::begin_transaction(); // 




   // 
   parent::prepare("UPDATE `topics` SET `moderated`=? WHERE `id`=?");
   parent::bind("V");
   parent::bind($topic_id);
   
   $s=parent::getsql();
   parent::query($s);

   //    
   $this->log_history($topic_id, 0, "V", $this->user_id, $user_name, "  id=".$topic_id);

   parent::commit_transaction(); // 

   return TRUE;

}


///////////////////////////////////////////////////////////////////////
// 
function CloseTopic($topic_id, $user_name, $password){
//,    
   parent::prepare("SELECT `id`, `moderated`, `answers` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);



   if(parent::fetch()){
     $moderated=parent::field("moderated");
     $answers=parent::field("answers");
   }else{
     throw new Exception("   ID=".$topic_id);
   }


   if($moderated==="Q"){
     $this->errors="     ID=".$topic_id;
     return FALSE;
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
          $this->errors="    .";
          return FALSE;
   }

   parent::begin_transaction(); // 




   // 
   parent::prepare("UPDATE `topics` SET `moderated`=? WHERE `id`=?");
   parent::bind("Q");
   parent::bind($topic_id);
   
   $s=parent::getsql();
   parent::query($s);

   //    
   $this->log_history($topic_id, 0, "Q", $this->user_id, $user_name, "  id=".$topic_id);

   parent::commit_transaction(); // 

   return TRUE;

}


///////////////////////////////////////////////////////////////////////
//    // 
function RestoreTopic($topic_id, $user_name, $password){
//,    
   parent::prepare("SELECT `id`, `moderated`, `answers` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $moderated=trim(parent::field("moderated"));
     $answers=parent::field("answers");
   }else{
     throw new Exception("   ID=".$topic_id);
   }


   if($moderated===""){
     $this->errors="     ,    ID=".$topic_id;
     return FALSE;
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
     $this->errors=" ,       .";
     return FALSE;
   }


   parent::begin_transaction(); // 

   parent::prepare("UPDATE `topics` SET `moderated`=?, `search_dumped`=0 WHERE `id`=?");
   parent::bind(" ");
   parent::bind($topic_id);
   
   $s=parent::getsql();
   parent::query($s);

   //    
   $this->log_history($topic_id, 0, "R", $this->user_id, $user_name, "  id=".$topic_id);

   parent::commit_transaction(); // 

   return TRUE;

}



///////////////////////////////////////////////////////////////////////
//  
function RenameTopic($topic_id, $user_name, $password, $title){

//,    
   parent::prepare("SELECT `id`, `moderated`, `answers`, `title` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $moderated=parent::field("moderated");
     $answers=parent::field("answers");
     $old_title=parent::field("title");
   }else{
     throw new Exception("   ID=".$topic_id);
   }


//   
   parent::prepare("SELECT `id`, `topic_id`, `user_name` FROM `messages` WHERE `topic_id`=? AND `id`=0");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
   }else{
     throw new Exception("     ID=".$topic_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }

   parent::begin_transaction(); // 

   if($moderator1!=1){
     if(trim($user_name1)===trim($user_name)){
       if($answers!=0){
          parent::rollback_transaction(); 
          $this->errors="    ,      .";
          return FALSE;
       }
     }else{
          parent::rollback_transaction(); 
          $this->errors="       .";
          return FALSE;
     }
   }

   //  
   parent::prepare("UPDATE `topics` SET `title`=?, `search_dumped`=0 WHERE `id`=?");
   parent::bind($title);
   parent::bind($topic_id);
   
   $s=parent::getsql();
   parent::query($s);



   //    
   $this->log_history($topic_id, 0, "R", $this->user_id, $user_name, "  id=".$topic_id."\n".
     $old_title);

   
   parent::commit_transaction(); // 

   return TRUE;
}


///////////////////////////////////////////////////////////////////////
// 
function ChangeMessage($topic_id, $message_id, $user_name, $password, $message_text){


//,   
   parent::prepare("SELECT `id`, `topic_id`, `user_name`, `message_text`, `moderated` FROM `messages` WHERE `topic_id`=? AND `id`=?");
   parent::bind($topic_id);
   parent::bind($message_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
     $old_message_text=parent::field("message_text");
     $moderated1=parent::field("moderated");
   }else{
     throw new Exception("    ID=".$topic_id.", =".$message_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }

   parent::begin_transaction(); // 

   if($moderator1!=1){
     if(trim($user_name1)!==trim($user_name)){
          parent::rollback_transaction(); 
          $this->errors="       .";
          return FALSE;
     }
   }


   // 
   parent::prepare("UPDATE `messages` SET `message_text`=?, `changed`=1 WHERE `topic_id`=? AND `id`=?");
   parent::bind($message_text);
   parent::bind($topic_id);
   parent::bind($message_id);
   
   $s=parent::getsql();
   parent::query($s);



   //    
   $this->log_history($topic_id, $message_id, "e", $this->user_id, $user_name, " :\n".
     $old_message_text);


   parent::commit_transaction(); // 

   return TRUE;
}

///////////////////////////////////////////////////////////////////////
// 
function HideMessage($topic_id, $message_id, $user_name, $password){


//,   
   parent::prepare("SELECT `id`, `topic_id`, `user_name`, `message_text`, `moderated` FROM `messages` WHERE `topic_id`=? AND `id`=?");
   parent::bind($topic_id);
   parent::bind($message_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
     $old_message_text=parent::field("message_text");
     $moderated1=parent::field("moderated");
   }else{
     throw new Exception("    ID=".$topic_id.", ".$message_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
     if(trim($user_name1)!==trim($user_name)){
          $this->errors="       .";
          return FALSE;
     }
   }

   parent::begin_transaction(); // 


   // 
   parent::prepare("UPDATE `messages` SET `moderated`=? WHERE `topic_id`=? AND `id`=?");
   parent::bind("H");
   parent::bind($topic_id);
   parent::bind($message_id);
   
   $s=parent::getsql();
   parent::query($s);



   //    
   $this->log_history($topic_id, $message_id, "H", $this->user_id, $user_name, " :\n".
     $old_message_text);


   parent::commit_transaction(); // 

   return TRUE;
}



///////////////////////////////////////////////////////////////////////
// 
function DeleteMessage($topic_id, $message_id, $user_name, $password){


//,   
   parent::prepare("SELECT `id`, `topic_id`, `user_name`, `message_text`, `moderated` FROM `messages` WHERE `topic_id`=? AND `id`=?");
   parent::bind($topic_id);
   parent::bind($message_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
     $old_message_text=parent::field("message_text");
     $moderated1=parent::field("moderated");
   }else{
     throw new Exception("    ID=".$topic_id.", ".$message_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
     if(trim($user_name1)!==trim($user_name)){
          $this->errors="       .";
          return FALSE;
     }
   }

   parent::begin_transaction(); // 


   // 
   parent::prepare("UPDATE `messages` SET `moderated`=? WHERE `topic_id`=? AND `id`=?");
   parent::bind("D");
   parent::bind($topic_id);
   parent::bind($message_id);
   
   $s=parent::getsql();
   parent::query($s);



   //    
   $this->log_history($topic_id, $message_id, "D", $this->user_id, $user_name, " :\n".
     $old_message_text);


   parent::commit_transaction(); // 

   return TRUE;
}


///////////////////////////////////////////////////////////////////////
//    
function RestoreMessage($topic_id, $message_id, $user_name, $password){


//,   
   parent::prepare("SELECT `id`, `topic_id`, `user_name`, `message_text`, `moderated` FROM `messages` WHERE `topic_id`=? AND `id`=?");
   parent::bind($topic_id);
   parent::bind($message_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $user_name1=parent::field("user_name");
     $old_message_text=parent::field("message_text");
     $moderated1=parent::field("moderated");
   }else{
     throw new Exception("    ID=".$topic_id.", ".$message_id);
   }


   $moderator1=$this->IsModerator($user_name, $password);

   if($moderator1==-1){
     return FALSE;
   }


   if($moderator1!=1){
          $this->errors="    .";
          return FALSE;
   }

   parent::begin_transaction(); // 


   // 
   parent::prepare("UPDATE `messages` SET `moderated`=? WHERE `topic_id`=? AND `id`=?");
   parent::bind(" ");
   parent::bind($topic_id);
   parent::bind($message_id);
   
   $s=parent::getsql();
   parent::query($s);



   //    
   $this->log_history($topic_id, $message_id, "R", $this->user_id, $user_name, " ");


   parent::commit_transaction(); // 

   return TRUE;
}





///////////////////////////////////////////////////////////////////////
//   
function SelectHistoryEvents($topic_id, $message_id){
   parent::prepare("SELECT `topic_id`, `message_id`, `user_id`, `user_name`, `updated_unixtime`, `message_text`, `event` ".
   "FROM `history` WHERE `topic_id`=? AND `message_id`=? ORDER BY `updated_unixtime`");
   parent::bind($topic_id);
   parent::bind($message_id);
   $s=parent::getsql();
   parent::query($s);
}

///////////////////////////////////////////////////////////////////////
//     
function GetNextHistoryEvent(){
   if(parent::fetch()){
     $this->user_id=parent::field("user_id");
     $this->user_name=parent::field("user_name");
     $this->time=date("d.m.Y-G:i", parent::field("updated_unixtime"));
     $this->message_text1=parent::field("message_text");
     $this->event=parent::field("event");
     return TRUE;
   }else{
     return FALSE;
   }
}





}//class


?>