<?            
//    

   require_once("t_sql.php");


class T_TABLES extends T_SQL {
   var $time; // 
   var $answers; //   
   var $id; //id 
   var $title1; // 
   var $message_text1; // 
   var $user_name; // 
   var $user_id; //id 
   var $password; // 
   var $errors; //,  \n
   var $user_answers; //  
   var $last_answer_un; //    -   
   var $email; //  
   var $last_answer_time; //   
   var $registration_time; //  
   var $moderated_topic; //  
   var $moderated_message; //   ()
   var $changed_message; //  


///////////////////////////////////////////////////////////////////////
// 
function T_TABLES(){
   parent::T_SQL("FORUM");
}


///////////////////////////////////////////////////////////////////////
function get_title(){
  return htmlspecialchars(trim($this->title1));

}


///////////////////////////////////////////////////////////////////////
function get_message_text(){
  return nl2br(htmlspecialchars(trim($this->message_text1)));

}


///////////////////////////////////////////////////////////////////////
//      $start_topic   $count
function select_topics($start_topic, $count) 
{

   parent::prepare("SELECT `id`, `title`, `answers`, `updated_unixtime`, `moderated` FROM `topics` WHERE `moderated`<>'D' ORDER BY `updated_unixtime`  DESC LIMIT ?,? ");
   parent::bind($start_topic);
   parent::bind($count);
   $sql=parent::getsql();
   //echo $sql;
   parent::query($sql);
}
///////////////////////////////////////////////////////////////////////
function get_next_topic() 
//     $id, $time, $answers
//       select_last_topics()
// TRUE,   ,  FALSE -   
{
   if(parent::fetch()){
     $this->time=date("d.m.Y-G:i", parent::field("updated_unixtime"));
     $this->answers=parent::field("answers");
     $this->id=parent::field("id");
     $this->title1=parent::field("title");
     $this->moderated_topic=parent::field("moderated");
     return TRUE;
   }else{
     return FALSE;
   }
}


///////////////////////////////////////////////////////////////////////
//      
function select_zero_topic($topic_id) 
{

   parent::prepare("SELECT `id`, `title`, `answers`, `moderated` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $this->title1=parent::field("title");
     $this->answers=parent::field("answers");
     $this->moderated_topic=parent::field("moderated");


   }else{
     throw new Exception("   ID=".$topic_id);
   }


   parent::prepare("SELECT `id`, `topic_id`, `message_text`, `user_name`, `updated_unixtime`, `user_id`, `moderated`, `changed` FROM `messages` WHERE `topic_id`=? AND `id`=0");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $this->message_text1=parent::field("message_text");
     $this->user_name=parent::field("user_name");
     $this->time=date("d.m.Y - G:i", parent::field("updated_unixtime"));
     $this->user_id=parent::field("user_id");
     $this->moderated_message=parent::field("moderated");
     $this->changed_message=parent::field("changed");

   }else{
     throw new Exception("      ID=".$topic_id);
   }
}


///////////////////////////////////////////////////////////////////////
//     $topic_id
function select_all_messages($topic_id) 
{
   parent::prepare("SELECT `id`, `topic_id`, `message_text`, `user_name`, `updated_unixtime`, `user_id`, `moderated`, `changed` FROM `messages` WHERE `topic_id`=? AND `id`>0 ORDER BY `id` ");

   parent::bind($topic_id);

   $sql=parent::getsql();
   parent::query($sql);
}

///////////////////////////////////////////////////////////////////////
//    $topic_id,    $start_message   $count 
function select_messages($topic_id, $start_message, $count) 
{
   parent::prepare("SELECT `id`, `topic_id`, `message_text`, `user_name`, `updated_unixtime`, `user_id`, `moderated`, `changed` FROM `messages` WHERE `topic_id`=? ORDER BY `id` LIMIT ?,?");

   parent::bind($topic_id);
   parent::bind($start_message);
   parent::bind($count);

   $sql=parent::getsql();
   parent::query($sql);
}


///////////////////////////////////////////////////////////////////////
function get_next_message() 
//     $id, $message_text, $user_name, $time
//       select_messages()
// TRUE,   ,  FALSE,     .
{
   if(parent::fetch()){
     $this->id=parent::field("id");
     $this->message_text1=parent::field("message_text");
     $this->user_name=parent::field("user_name");
     $this->time=date("d.m.Y - G:i", parent::field("updated_unixtime"));
     $this->user_id=parent::field("user_id");
     $this->moderated_message=parent::field("moderated");
     $this->changed_message=parent::field("changed");

     return TRUE;
   }else{
     return FALSE;
   }
}



///////////////////////////////////////////////////////////////////////
function has_special_chars($s){
// TRUE,      HTML
   $s1=trim($s);
   $s2=htmlspecialchars($s1);
   if($s1 === $s2){
     return FALSE;
   }
   return TRUE;

}



///////////////////////////////////////////////////////////////////////
function add_user($user, $password, $password1, $email){
//  .
//  (,    )     $errors  FALSE.
//  ,   TRUE.
   $this->errors="";
  
   $u=trim($user);

   if (empty($u)){
     $this->errors .= "  .\n";
   }

   if (empty($password)){
     $this->errors .= " .\n";
   }

   if (empty($email)){
     $this->errors .= " e-mail.\n";
   }


   if($this->has_special_chars($u)){
     $this->errors .= "      .\n";
   }

   if($this->has_special_chars($email)){
     $this->errors .= "      .\n";
   }

   if($password!==$password1){
     $this->errors .= "   .\n";
   }

   if($this->errors!==""){
     return FALSE;
   }


   parent::prepare("SELECT `user_name` FROM `users` WHERE `user_name`=?");
   parent::bind($u);

   $sql=parent::getsql();
   parent::query($sql);
   if(parent::fetch()){
     $this->errors .= "     .\n";
     return FALSE;
   }


   parent::prepare("INSERT INTO `users` (`user_name` , `password` , `email`, `registration_time`)  VALUES (?, ?, ?, ?)");
   parent::bind($u);
   parent::bind(md5(trim($password))); //      MD5
   parent::bind(trim($email));
   parent::bind(time());
   $s=parent::getsql();
   parent::query($s);

   return TRUE; // 

}


///////////////////////////////////////////////////////////////////////
function check_user_password($user_name, $password){
//    .  user_id  0,    .
//  ,   TRUE.
//  ,   FALSE      $errors
//        ,    ,   0  .
//  $user_answers  $last_answer_un

   $user_name=trim($user_name);
   $password=trim($password);

   if (empty($user_name)){
     $this->errors .= "  .\n";
     return 0;
   }

   if($this->has_special_chars($user_name)){
     $this->errors .= "      .\n";
     return 0;
   }


   parent::prepare("SELECT `id`, `user_name`, `password`, `answers`, `last_answer_un`  FROM `users` WHERE `user_name`=?");

   parent::bind($user_name);

   $sql=parent::getsql();
   parent::query($sql);

   $ok=0;
   $pass1="";
   if(parent::fetch()){
     $ok=1;
     $pass1=trim(parent::field("password"));
     $id=parent::field("id");
     $this->user_answers=parent::field("answers");
     $this->last_answer_un=trim(parent::field("last_answer_un"));

   }
   parent::free();

   if($ok==0){//       
     if(empty($password)){ //    ,     -  
       return 0;  
     }else{
       $this->errors .= "         .\n";
       return 0;
     }
   }else{
     if(empty($password)){
       $this->errors .= "     ".$user_name.".\n";
       return 0;
     }else{
       //,   
       $p1=md5(trim($password));
       if($p1===$pass1){
         return $id; // 
       }else{
         $this->errors .= "      ".$user_name.".\n";
         return 0;
       }
     }
   }

}



///////////////////////////////////////////////////////////////////////
function read_user_card($user_id){
   if ($user_id==0){
     throw new Exception(" ID : ".$user_id);
   }

   parent::prepare("SELECT `id`, `user_name`, `answers`, `email`, `last_answer_time`, `registration_time`  FROM `users` WHERE `id`=?");
   parent::bind($user_id);
   $sql=parent::getsql();
   parent::query($sql);
   $ok=FALSE;

   if(parent::fetch()){
     $this->user_name=trim(parent::field("user_name"));
     $this->user_answers=trim(parent::field("answers"));
     $this->email=trim(parent::field("email"));
     $this->registration_time=trim(parent::field("registration_time"));
     $this->last_answer_time=trim(parent::field("last_answer_time"));
     $ok=TRUE;
  }
   parent::free();
   return $ok;
}


///////////////////////////////////////////////////////////////////////
function change_user_email($user_id, $email, $password){
//  e-mail   
   $user_id=(int)$user_id;

   if ($user_id<=0){
     throw new Exception(" ID : ".$user_id);
   }

   $email=trim($email);
   $password=md5(trim($password));


   parent::prepare("SELECT `id`, `user_name`, `password`  FROM `users` WHERE `id`=?");
   parent::bind($user_id);
   $sql=parent::getsql();
   parent::query($sql);
   $ok=FALSE;

   if(parent::fetch()){
     $user_name=trim(parent::field("user_name"));
     $password1=trim(parent::field("password"));
     $ok=TRUE;
   }

   if(!$ok){
     throw new Exception("     ID: ".$user_id);
   }

   $this->errors="";

   if($password1!==$password){
     $this->errors.="   ".$user_name."\n";
     return FALSE;
   }

   if($this->has_special_chars($email)){
     $this->errors.="       \n";
     return FALSE;
   }

     parent::prepare("UPDATE `users` SET `email`=? WHERE `id`=?");
     parent::bind($email);
     parent::bind($user_id);
     
     $s=parent::getsql();
     parent::query($s);
   return TRUE;
}




///////////////////////////////////////////////////////////////////////
function add_topic($title, $message, $user_name, $password, $un) 
//    .
//  (,    - )  $errors   FALSE.
//  ,   TRUE.
{

   if (strlen($un) != 16){
     throw new Exception("   un  16  "+$un);
   }


   $this->errors .= "";

   if(trim($title)===""){
     $this->errors .= "  .\n";
   }
   if (trim($message)===""){
     $this->errors .= "  .\n";
   }
   $user_id=$this->check_user_password($user_name, $password);
   // last_answer_un  user_answers

   if (!empty($this->errors)){
     return FALSE;
   }

   if($user_id!=0){
     if($this->last_answer_un===$un){
        $this->errors .= "        .\n";
     }
   }
 

     $last_answer_time=time();


     parent::begin_transaction(); // 

     parent::prepare("INSERT INTO `topics` (`title` , `answers` , `updated_unixtime`)  VALUES (?, ?, ?)");
     parent::bind($title);
     parent::bind(0);
     parent::bind($last_answer_time);

     $s=parent::getsql();
     parent::query($s);


     $id=parent::last_insert_id(); //    id 


     parent::prepare("INSERT INTO `messages` (`id` , `topic_id`, `user_name` , `message_text` , `updated_unixtime`, `user_id`)  VALUES (?, ?, ?, ?, ?, ?)");
     parent::bind(0);
     parent::bind($id);
     parent::bind($user_name);
     parent::bind($message);
     parent::bind($last_answer_time);
     parent::bind($user_id);
     $s=parent::getsql();
     parent::query($s);

   //  
   if($user_id!=0){

     $this->update_user_card($user_id, ($this->user_answers+1), $last_answer_time, $this->last_answer_un);

   }

     parent::commit_transaction(); // 

     $this->id=$id;


     $this->add_topic_to_search_queue($id);

     $this->move_topic_to_search();

     $this->move_old_topic_to_archive($id);


     return TRUE; // 
}


///////////////////////////////////////////////////////////////////////
//    
function count_messages_in_topic($topic_id){

   parent::prepare("SELECT COUNT(`id`) AS `number_of_messages` FROM `messages` WHERE `topic_id`=?");

   parent::bind($topic_id);
   $sql=parent::getsql();
   //echo $sql;
   parent::query($sql);
   if(parent::fetch()){
     $n=parent::field("number_of_messages");
     return $n;
   }
   return 0;
}



///////////////////////////////////////////////////////////////////////
function update_user_card($user_id, $user_answers, $last_answer_time, $last_un){
//  
     parent::prepare("UPDATE `users` SET `answers`=?, `last_answer_time`=?, `last_answer_un`=\"?\" WHERE `id`=?");
     parent::bind($user_answers);
     parent::bind($last_answer_time);
     parent::bind($last_un);
     parent::bind($user_id);
     
     $s=parent::getsql();
     parent::query($s);
}


///////////////////////////////////////////////////////////////////////
function add_message($topic_id, $message, $user_name, $password, $un) 
//    .
//  (,    - )     $errors  FALSE.
//  ,   TRUE.
{
   $user_name=trim($user_name);
   $message=trim($message);
   $password=trim($password);
   $un=trim($un);

   $this->errors = "";

   if (empty($topic_id)){
     throw new Exception("  topic_id");
   }
   if (!is_int($topic_id)){
     throw new Exception("topic_id -   ");
   }
   if ($topic_id < 1){
     throw new Exception("topic_id < 1");
   }
   if (strlen($un) != 16){
     throw new Exception("   un  16  "+$un);
   }


   if (trim($message)===""){
     $this->errors .= "  .\n";
   }

   $user_id=$this->check_user_password($user_name, $password);
   // last_answer_un  user_answers


   if($user_id!=0){
     if($this->last_answer_un===$un){
        $this->errors .= "        .\n";
     }
   }
 



   if (!empty($this->errors)){
     return FALSE;
   }


   //   
   parent::prepare("SELECT `id`, `answers`, `moderated` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $s=parent::getsql();
   parent::query($s);

   if(parent::fetch()){
    $moderated=parent::field("moderated");
   }else{
    throw new Exception("    id=" . $f_id);
   }


   $last_answer_time=time();


   parent::begin_transaction(); // 


   $n=$this->count_messages_in_topic($topic_id);

   // 

   parent::prepare("INSERT INTO `messages` (`id` , `topic_id`, `user_name` , `message_text` , `updated_unixtime`, `user_id`)  VALUES (?, ?, ?, ?, ?, ?)");
   parent::bind($n);
   parent::bind($topic_id);
   parent::bind($user_name);
   parent::bind($message);
   parent::bind($last_answer_time);
   parent::bind($user_id);
   $s=parent::getsql();
   parent::query($s);



   if($moderated!=="V"){
   //       

     parent::prepare("UPDATE `topics` SET `answers`=?, `updated_unixtime`=? WHERE `id`=?");
     parent::bind($n);
     parent::bind($last_answer_time);
     parent::bind($topic_id);
     
     $s=parent::getsql();
     parent::query($s);

   }else{
     //     
     parent::prepare("UPDATE `topics` SET `answers`=? WHERE `id`=?");
     parent::bind($n);
     parent::bind($topic_id);
     
     $s=parent::getsql();
     parent::query($s);
   }


   //  
   if($user_id!=0){

     $this->update_user_card($user_id, ($this->user_answers+1), $last_answer_time, $this->last_answer_un);

   }
   parent::commit_transaction(); // 


   $this->add_topic_to_search_queue($topic_id);

   $this->move_topic_to_search();


   return TRUE; // 
}




///////////////////////////////////////////////////////////////////////
function add_topic_to_search_queue($topic_id){
  parent::prepare("SELECT `topic_id` FROM `SEARCH_QUEUE` WHERE `topic_id`=?");
   parent::bind($topic_id);
   $s=parent::getsql();
   parent::query($s);

   if(parent::fetch()){

     parent::prepare("UPDATE `search_queue` SET `updated_unixtime`=? WHERE `topic_id`=?");
     parent::bind(time());
     parent::bind($topic_id);
     
     $s=parent::getsql();
     parent::query($s);

   }else{

     parent::prepare("INSERT INTO `search_queue` (`topic_id`, `updated_unixtime`)  VALUES (?, ?)");
     parent::bind($topic_id);
     parent::bind(time());
     $s=parent::getsql();
     //echo $s;
     parent::query($s);

   }

}



///////////////////////////////////////////////////////////////////////
//      
//  title1  answers
function GetTextOfTopic($topic_id){
   $s="";

   parent::prepare("SELECT `id`, `title`, `answers`, `moderated` FROM `topics` WHERE `id`=?");
   parent::bind($topic_id);
   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){
     $moder=trim(parent::field("moderated"));
     if($moder==="D"){ 
       return ""; //  -     ...
     }

     $s = parent::field("title");
     $this->title1=$s;

     $this->answers = parent::field("answers");


   }else{
     throw new Exception("   ID=".$topic_id);
   }

   parent::prepare("SELECT `id`, `topic_id`, `message_text`, `user_name`, `user_id`, `moderated` FROM `messages` WHERE `topic_id`=? ORDER BY `id`");
   parent::bind($topic_id);

   $sql=parent::getsql();
   parent::query($sql);

   while(parent::fetch()){
     $moder=trim(parent::field("moderated"));

     if($moder===""){

       $s .= "\n" .
       parent::field("message_text") .
       "\n".
       parent::field("user_name")."\n";

     }

   }
   return $s;

}


///////////////////////////////////////////////////////////////////////
//   ,      20 
function move_topic_to_search() 
{

   parent::prepare("SELECT `topic_id`, `updated_unixtime` FROM `SEARCH_QUEUE` WHERE `updated_unixtime`<?");
   parent::bind(time()+20*60); //20 

   $sql=parent::getsql();
   parent::query($sql);
   if(!parent::fetch()){
     return FALSE; 
   }
   $id=parent::field("topic_id");
   $updated_unixtime=parent::field("updated_unixtime");

   $full_text=$this->GetTextOfTopic($id);  //  title1  answers


   //,      

   parent::prepare("SELECT `topic_id` FROM `search` WHERE `topic_id`=?");
   parent::bind($id);

   $sql=parent::getsql();
   parent::query($sql);

   if(parent::fetch()){

     //  ,   UPDATE


     parent::prepare("UPDATE `search` SET `full_text`=?, `title`=?, `answers`=? WHERE `topic_id`=?");
     parent::bind($full_text);
     parent::bind($this->title1);
     parent::bind($this->answers);
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);

   }else{
     //  ,   INSERT


     parent::prepare("INSERT INTO `search` (`topic_id`, `full_text` , `title` , `answers`)  VALUES (?, ?, ?, ?)");
     parent::bind($id);
     parent::bind($full_text);
     parent::bind($this->title1);
     parent::bind($this->answers);
     
     $s=parent::getsql();
     parent::query($s);
   }

   parent::begin_transaction();

   parent::prepare("SELECT `topic_id`, `updated_unixtime` FROM `SEARCH_QUEUE` WHERE `topic_id`=?");
   parent::bind($id); 

   $sql=parent::getsql();
   parent::query($sql);
   if(!parent::fetch()){
     throw new Exception("   ID=".$id);
   }
   $updated_unixtime1=parent::field("updated_unixtime");


   if($updated_unixtime1==$updated_unixtime){

   //   ,    

     parent::prepare("DELETE FROM `SEARCH_QUEUE` WHERE `topic_id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);
   }

   parent::commit_transaction();
   return TRUE;
}


///////////////////////////////////////////////////////////////////////
function move_old_topic_to_archive($topic_id){

   // ,   
   parent::prepare("SELECT * FROM `TOPICS` WHERE `id` <= ? LIMIT 1");
   parent::bind($topic_id-1000); 

   $sql=parent::getsql();
   parent::query($sql);
   if(!parent::fetch()){
     return FALSE; 
   }


   parent::begin_transaction();


   $id=parent::field("id");
   $title=parent::field("title");
   $answers=parent::field("answers");
   $updated_unixtime=parent::field("updated_unixtime");
   $moderated=parent::field("moderated");


   //       id  
     parent::prepare("DELETE FROM `ARCHIVE_TOPICS` WHERE `id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);


     parent::prepare("DELETE FROM `ARCHIVE_MESSAGES` WHERE `topic_id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);



     parent::prepare("INSERT INTO `ARCHIVE_TOPICS` (`id`, `title` , `answers`, `updated_unixtime`, `moderated`)  VALUES (?, ?, ?, ?, ?)");
     parent::bind($id);
     parent::bind($title);
     parent::bind($answers);
     parent::bind($updated_unixtime);
     parent::bind($moderated);
     
     $s=parent::getsql();
     parent::query($s);


     for($i=0; $i<=$answers; $i++){
       parent::prepare("SELECT * FROM `MESSAGES` WHERE `topic_id` = ? AND `id` = ?");
       parent::bind($id); 
       parent::bind($i); 

       $sql=parent::getsql();
       parent::query($sql);
       if(!parent::fetch()){
         continue;  //  -  
       }

       $message_text=parent::field("message_text");
       $user_id=parent::field("user_id");
       $user_name=parent::field("user_name");
       $updated_unixtime=parent::field("updated_unixtime");
       $moderated=parent::field("moderated");
       $changed=parent::field("changed");

       parent::prepare("INSERT INTO `ARCHIVE_MESSAGES` (`id`, `topic_id` , `message_text`, `user_id`, `user_name`, `updated_unixtime`, `moderated`, `changed`)  VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
       parent::bind($i);
       parent::bind($id);
       parent::bind($message_text);
       parent::bind($user_id);
       parent::bind($user_name);
       parent::bind($updated_unixtime);
       parent::bind($moderated);
       parent::bind($changed);
       
       $s=parent::getsql();
       parent::query($s);
     }

   $full_text=$this->GetTextOfTopic($id);  //  title1  answers


   //    ,   

     parent::prepare("DELETE FROM `ARCHIVE_SEARCH` WHERE `topic_id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);


     //  

     parent::prepare("INSERT INTO `ARCHIVE_SEARCH` (`topic_id`, `full_text` , `title` , `answers`)  VALUES (?, ?, ?, ?)");
     parent::bind($id);
     parent::bind($full_text);
     parent::bind($this->title1);
     parent::bind($this->answers);
     
     $s=parent::getsql();
     parent::query($s);
   






   //  
     parent::prepare("DELETE FROM `SEARCH` WHERE `topic_id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);

     parent::prepare("DELETE FROM `TOPICS` WHERE `id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);


     parent::prepare("DELETE FROM `MESSAGES` WHERE `topic_id`=?");
     parent::bind($id);
     
     $s=parent::getsql();
     parent::query($s);





   parent::commit_transaction();

   return TRUE;


}

///////////////////////////////////////////////////////////////////////
function search_query($query, $start_row, $rows_in_page){

//SELECT * FROM articles WHERE MATCH (title,body) AGAINST ('MySQL');

   parent::prepare("SELECT `topic_id`, `title`, `answers` FROM `search` WHERE MATCH (`full_text`) AGAINST (?) LIMIT ?,?");
   parent::bind($query); 
   parent::bind($start_row); 
   parent::bind($rows_in_page); 

   $sql=parent::getsql();
   parent::query($sql);

   $rows=parent::num_rows();

   return $rows;
}


///////////////////////////////////////////////////////////////////////
function search_fetch(){

   if(!parent::fetch()) return FALSE;

   $this->id=parent::field("topic_id");
   $this->title=parent::field("title");
   $this->answers=parent::field("answers");

   return TRUE;

}


}//class


?>